﻿using System.Collections;
namespace Observer.Ejm1
{
    /// <summary>
    /// Esta clase abstracta representa los objetos susceptibles de ser
    /// observados. Incorpora metodos para agregar y eliminar observadores
    /// y un metodo de notificacion. La asociacion Observable-Observadores
    /// se implementa mediante un vector de observadores
    /// </summary>


    public abstract class Observable
    {
        // Este atributo privado mantiene el vector con los observadores
        private ArrayList observadores;

        // El constructor crea el vector con la asociacion Observable-Observador
        public Observable()
        {
            observadores = new ArrayList();
        }

        // Agregar y eliminar sencillamente operan sobre vector _observadores...
        public void AgregarObservador(Observador o)
        {
            observadores.Add(o);
        }

        public void EliminarObservador(Observador o)
        {
            observadores.Remove(o);
        }

        // Notificacion: Para cada observador se invoca el mÃ©todo actualizar().
        public void NotificarObservadores()
        {
            foreach (Observador o in observadores)
            {
                o.Actualizar();
            }
        }
    }
}
